module Contender
  # Set that uses copy-on-write to guarantee thread safety
  #
  # Use this when read throughput is the primary requirement; write operations will always be
  # slow due to the need to create a shallow copy of the set to perform operations on.
  class CopyOnWriteSet
    include CopyOnWriteStructure
    include Enumerable

    delegate_to Set

    mutators :<<, :add, :add?, :clear, :collect!, :delete, :delete?, :delete_if, :flatten!,
      :keep_if, :map!, :merge, :reject!, :replace, :select!, :subtract

    accessors!
  end # CopyOnWriteSet
end
