module Contender
  # Simplified interface to an atomic reference that acts as a counter
  class Counter < Atomic
    # @return [undefined]
    def initialize(initial = 0)
      super initial
    end

    # Increments the value of this counter by 1
    # @return [Integer] The new value of this counter
    def increment
      update do |count|
        count = count + 1
      end
    end

    # Decrements the value of this counter by 1
    # @return [Integer] The new value of this counter
    def decrement
      update do |count|
        count = count - 1
      end
    end

    # @return [String]
    def inspect
      "#<Contender::Counter = #{value}>"
    end
  end # Counter
end
