module Contender
  # Raised when attempting to retrieve the result of a task that was cancelled
  class CancellationError < RuntimeError; end

  # Raised when a blocking operation times out
  class TimeoutError < RuntimeError; end

  # Raised when a thread is interrupted during the execution of a task
  class InterruptError < ThreadError; end

  # Raised when an operation can not be completed because the object is not in the correct state
  class InvalidStateError < RuntimeError; end

  # Raised when attempting to retrieve the result of a task that aborted by raising an exception
  class ExecutionError < RuntimeError
    # @return [Exception]
    attr_reader :cause

    # @param [Exception] cause
    # @return [undefined]
    def initialize(cause)
      @cause = cause
      set_backtrace cause.backtrace
    end
  end
end
