module Contender
  # @abstract
  class ThreadFactory
    # @abstract
    # @yield
    # @return [Thread]
    def create(&block)
      raise NotImplementedError
    end
  end

  class SimpleThreadFactory < ThreadFactory
    # @return [ThreadGroup]
    attr_reader :group

    # @return [Integer]
    attr_accessor :priority

    # @return [undefined]
    def initialize
      @group = ThreadGroup.new
      @priority = 0
    end

    # @api public
    # @yield
    # @return [Thread]
    def create(&block)
      thread = Thread.new &block
      thread.priority = @priority

      @group.add thread

      thread
    end
  end
end
